;; Chinese boxes (odd side version)
;; MPradella 25/3/2006

;; Grammar: (/ stands for vertical .)
;; S -> BV S1 | x | S S | S / S
;; S1 -> S2 BV
;; S2 -> BO / S3
;; S3 -> S / BO
;; BV -> X1 / BV1
;; BV1 -> O1 / BV1 | x
;; BO -> O1 BO | o
;; O1 -> o
;; X1 -> x

(require (file "/home/pradella/docs/2d/mazpa/kolam.scm"))

(define *t-rules* 
  '((x   S BV1 X1)
    (o   BO O1)
    ))

(define *h-rules*
  '(((S . S) S)
    ((BV . S1)  S)
    ((S2 . BV)  S1)
    ((O1 . BO)  BO)
    ))

(define *v-rules*
  '(((S . S) S)
    ((BO . S3)  S2)
    ((S . BO)   S3)
    ((X1 . BV1) BV)
    ((O1 . BV1) BV1)
    ))

(set-rules! *t-rules* *h-rules* *v-rules*)

(toggle-trace!) ; this enables tracing

(parse!
  '((x o x x o o o x x)
    (o x o o x o x o x)
    (x o x o o x o o x)
    (x o x o x o x o x)
    (o x o x o o o x x)
    (x o x x x x x x x)))

