;;; Here is defined the RT language of pictures with palindromic rows, in which
;;; each row is an even palindrome over {a,b}
;;;
;;; lucajdvr 25/11/2008
;;;
;;; Grammar:
;;;      ||# # # #||
;;;      ||# R R #||   ||# # # #||
;;; S -> ||# S S #|| | ||# R R #||
;;;      ||# S S #||   ||# # # #||
;;;      ||# # # #||
;;;
;;;      ||# # # # # #||   ||# # # # # #||   ||# # # #||   ||# # # #||
;;; R -> ||# A R R A'#|| | ||# B R R B'#|| | ||# A A'#|| | ||# B B'#||
;;;      ||# # # # # #||   ||# # # # # #||   ||# # # #||   ||# # # #||
;;;
;;; A->a    B->b    A'->a    B'->b
;;;

; to use it: mzscheme --script palindroms.scm

(require (file "/home/pradella/docs/2d/mazpa/rtg.scm"))


(define *fs-rules* 
  `((a   A A1)
    (b   B B1)))

(define *vs-rules*
  '((S (($ $ $ $) 
	($ R R $)
	($ S S $)
	($ S S $)
	($ $ $ $))
       (($ $ $ $) 
	($ R R $)
	($ $ $ $)))
    (R (($ $ $ $ $  $)
	($ A R R A1 $)
	($ $ $ $ $  $))
       (($ $ $ $ $  $)
	($ B R R B1 $)
	($ $ $ $ $  $))
       (($ $ $  $)
	($ A A1 $)
	($ $ $  $))
       (($ $ $  $) 
	($ B B1 $)
	($ $ $  $)))))


(define *picture* '((b a a b)
		    (b b b b)
		    (a b b a)
		    (a a a a)))

(toggle-trace!)
(set-rules! *fs-rules* *vs-rules*)
(parse! *picture*)
